---
name: Bug report
about: Report a bug in the project
title: ''
labels: ''
assignees: ''

---

## If you have a crash on startup, please make sure your graphics drivers are up to date before submitting a bug report.

**What is your GPU driver version? Old drivers, particularly on Nvidia, are known to cause crashes on boot on 1.1.0. If you are on Nvidia and the game is crashing on boot, please update to driver version 555.85 or newer before opening an issue.**

**Have you checked whether this issue is vanilla behavior? In other words, does it occur on original hardware?**

**Were you playing with intended mechanics, or using glitches? If it's the latter, which glitches?**

**Describe the bug**
A clear and concise description of what the bug is.

**To Reproduce**
Steps to reproduce the behavior:
1. Go to '...'
2. etc.

**Expected behavior**
A clear and concise description of what you expected to happen.

**Screenshots**
Please attach a screenshot of the bug.

**Desktop (please complete the following information):**
 - OS: [Windows 10, Windows 11, Linux distro]
 - Version: [e.g. 1.0.0]
 - CPU: [e.g. Intel Core ..., AMD Ryzen ..., etc.]
 - GPU: [e.g. NVIDIA GeForce .../Radeon RX .../Intel UHD .../etc.]
 - GPU driver: [e.g Nvidia driver 545.XX, AMD driver 24.X.X, etc]

**Additional context**
Add any other context about the problem here.
